Index: trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90	(revision 3275)
@@ -300,6 +300,6 @@
       real omega(ngrid,nlayer)            ! omega velocity (Pa/s, >0 when downward)
 
-      integer i,l,ig,ierr,iq,nw,isoil,iesp, igcm_generic_vap, igcm_generic_ice
-      logical call_ice_vap_generic ! to call only one time the ice/vap pair of a tracer
+      integer i,l,ig,ierr,iq,nw,isoil,iesp, igcm_generic_gas, igcm_generic_ice
+      logical call_ice_gas_generic ! to call only one time the ice/vap pair of a tracer
 
       real zls                       ! Solar longitude (radians).
@@ -638,5 +638,5 @@
          qsurf_hist(:,:)=qsurf(:,:)
 
-!!         call WriteField_phy("post_qsurf_hist_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
+!!         call WriteField_phy("post_qsurf_hist_qsurf",qsurf(1:ngrid,igcm_h2o_gas),1)
 
 !        Initialize variable for dynamical heating and zonal wind tendency diagnostic
@@ -681,5 +681,5 @@
          endif
 
-!!         call WriteField_phy("post_physdem_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
+!!         call WriteField_phy("post_physdem_qsurf",qsurf(1:ngrid,igcm_h2o_gas),1)
 #endif
          if (corrk) then
@@ -702,5 +702,5 @@
          endif
 
-!!         call WriteField_phy("post_corrk_firstcall_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
+!!         call WriteField_phy("post_corrk_firstcall_qsurf",qsurf(1:ngrid,igcm_h2o_gas),1)
          ! XIOS outputs
 #ifdef CPP_XIOS
@@ -711,11 +711,11 @@
 #endif
 
-!!         call WriteField_phy("post_xios_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
+!!         call WriteField_phy("post_xios_qsurf",qsurf(1:ngrid,igcm_h2o_gas),1)
 
          write(*,*) "physiq: end of firstcall"
       endif ! end of 'firstcall'
 
-!!      call WriteField_phy("post_firstcall_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
-!!      call writediagfi(ngrid,"firstcall_post_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
+!!      call WriteField_phy("post_firstcall_qsurf",qsurf(1:ngrid,igcm_h2o_gas),1)
+!!      call writediagfi(ngrid,"firstcall_post_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_gas))
 
       if (check_physics_inputs) then
@@ -882,6 +882,6 @@
             ! Eclipse incoming sunlight !AF24: removed
 
-!!            call writediagfi(ngrid,"corrk_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
-!!            call writediagfi(ngrid,"corrk_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
+!!            call writediagfi(ngrid,"corrk_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_gas))
+!!            call writediagfi(ngrid,"corrk_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_gas))
 
 
@@ -900,12 +900,12 @@
                   do iq=1,nq
 
-                     call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-
-                     if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
+                     call generic_tracer_index(nq,iq,igcm_generic_gas,igcm_generic_ice,call_ice_gas_generic)
+
+                     if (call_ice_gas_generic) then ! to call only one time the ice/vap pair of a tracer
 
                         epsi_generic=constants_epsi_generic(iq)
 
-                        muvar(1:ngrid,1:nlayer)=mugaz/(1.e0+(1.e0/epsi_generic-1.e0)*pq(1:ngrid,1:nlayer,igcm_generic_vap))
-                        muvar(1:ngrid,nlayer+1)=mugaz/(1.e0+(1.e0/epsi_generic-1.e0)*pq(1:ngrid,nlayer,igcm_generic_vap))
+                        muvar(1:ngrid,1:nlayer)=mugaz/(1.e0+(1.e0/epsi_generic-1.e0)*pq(1:ngrid,1:nlayer,igcm_generic_gas))
+                        muvar(1:ngrid,nlayer+1)=mugaz/(1.e0+(1.e0/epsi_generic-1.e0)*pq(1:ngrid,nlayer,igcm_generic_gas))
 
                      endif
@@ -931,5 +931,5 @@
                 call callcorrk(ngrid,nlayer,pq,nq,qsurf,                          &
                               albedo,albedo_equivalent,emis,mu0,pplev,pplay,pt,   &
-                              tsurf,fract,dist_star,aerosol,muvar,                &
+                              zzlay,tsurf,fract,dist_star,aerosol,muvar,                &
                               zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,                &
                               fluxsurfabs_sw,fluxtop_lw,                          &
@@ -1039,6 +1039,6 @@
       endif ! of if (callrad)
 
-!!      call writediagfi(ngrid,"vdifc_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
-!!      call writediagfi(ngrid,"vdifc_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
+!!      call writediagfi(ngrid,"vdifc_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_gas))
+!!      call writediagfi(ngrid,"vdifc_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_gas))
 
 
@@ -1137,5 +1137,5 @@
          ! endif
 
-!!         call writediagfi(ngrid,"vdifc_post_zdqsdif"," "," ",2,zdqsdif(1:ngrid,igcm_h2o_vap))
+!!         call writediagfi(ngrid,"vdifc_post_zdqsdif"," "," ",2,zdqsdif(1:ngrid,igcm_h2o_gas))
 
          if (tracer) then
@@ -1144,6 +1144,6 @@
          end if ! of if (tracer)
 
-!!         call writediagfi(ngrid,"vdifc_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
-!!         call writediagfi(ngrid,"vdifc_post_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
+!!         call writediagfi(ngrid,"vdifc_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_gas))
+!!         call writediagfi(ngrid,"vdifc_post_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_gas))
 
          ! test energy conservation
@@ -1264,6 +1264,6 @@
          dqsurf(1:ngrid,igcm_n2) = dqsurf(1:ngrid,igcm_n2) + zdqsc(1:ngrid,igcm_n2)
 
-!!         call writediagfi(ngrid,"condense_n2_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
-!!         call writediagfi(ngrid,"condense_n2_post_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
+!!         call writediagfi(ngrid,"condense_n2_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_gas))
+!!         call writediagfi(ngrid,"condense_n2_post_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_gas))
 
          ! test energy conservation
@@ -1458,6 +1458,6 @@
                cloudfrac(:,:)=0.0
                do iq=1,nq
-                  call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-                  if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
+                  call generic_tracer_index(nq,iq,igcm_generic_gas,igcm_generic_ice,call_ice_gas_generic)
+                  if (call_ice_gas_generic) then ! to call only one time the ice/vap pair of a tracer
                      do l = 1, nlayer
                         do ig=1,ngrid
@@ -1491,5 +1491,5 @@
             dqsurf(1:ngrid,1:nq) = dqsurf(1:ngrid,1:nq) + zdqssed(1:ngrid,1:nq)
 
-!!            call writediagfi(ngrid,"callsedim_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
+!!            call writediagfi(ngrid,"callsedim_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_gas))
 
             ! ! Test water conservation !AF24: removed
@@ -1497,6 +1497,6 @@
          end if ! end of 'sedimentation'
 
-!!         call writediagfi(ngrid,"mass_redist_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
-!!         call writediagfi(ngrid,"mass_redist_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
+!!         call writediagfi(ngrid,"mass_redist_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_gas))
+!!         call writediagfi(ngrid,"mass_redist_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_gas))
 
   ! ---------------
@@ -1509,6 +1509,6 @@
             zdmassmr(1:ngrid,1:nlayer) = mass(1:ngrid,1:nlayer) * 0
             !    (   zdqevap(1:ngrid,1:nlayer)                          &
-            !    !   + zdqrain(1:ngrid,1:nlayer,igcm_h2o_vap)             &
-            !    !   + dqmoist(1:ngrid,1:nlayer,igcm_h2o_vap)             &
+            !    !   + zdqrain(1:ngrid,1:nlayer,igcm_h2o_gas)             &
+            !    !   + dqmoist(1:ngrid,1:nlayer,igcm_h2o_gas)             &
             !      + dqvaplscale(1:ngrid,1:nlayer) )
 
@@ -1536,8 +1536,8 @@
          endif
 
-!         call writediagfi(ngrid,"mass_redistribution_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
-
-!!         call writediagfi(ngrid,"slab_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
-!!         call writediagfi(ngrid,"slab_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
+!         call writediagfi(ngrid,"mass_redistribution_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_gas))
+
+!!         call writediagfi(ngrid,"slab_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_gas))
+!!         call writediagfi(ngrid,"slab_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_gas))
 
 
@@ -1794,12 +1794,12 @@
          do iq=1,nq
 
-            call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-
-            if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
+            call generic_tracer_index(nq,iq,igcm_generic_gas,igcm_generic_ice,call_ice_gas_generic)
+
+            if (call_ice_gas_generic) then ! to call only one time the ice/vap pair of a tracer
 
                do l = 1, nlayer
                   do ig=1,ngrid
                      call Psat_generic(zt(ig,l),pplay(ig,l),metallicity,psat_tmp_generic,qsat_generic(ig,l,iq))
-                     RH_generic(ig,l,iq) = zq(ig,l,igcm_generic_vap) / qsat_generic(ig,l,iq)
+                     RH_generic(ig,l,iq) = zq(ig,l,igcm_generic_gas) / qsat_generic(ig,l,iq)
                   enddo
                enddo
@@ -2364,7 +2364,7 @@
 
       do iq=1,nq
-         call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-
-         if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
+         call generic_tracer_index(nq,iq,igcm_generic_gas,igcm_generic_ice,call_ice_gas_generic)
+
+         if (call_ice_gas_generic) then ! to call only one time the ice/vap pair of a tracer
 
             reffrad_generic_zeros_for_wrf(:,:) = 1.
@@ -2373,5 +2373,5 @@
             comm_TOTCLOUDFRAC(1:ngrid) = totcloudfrac(1:ngrid) !??????
             comm_SURFRAIN(1:ngrid) = zdqsrain_generic(1:ngrid,iq)
-            comm_DQVAP(1:ngrid,1:nlayer) = pdq(1:ngrid,1:nlayer,igcm_generic_vap)
+            comm_DQVAP(1:ngrid,1:nlayer) = pdq(1:ngrid,1:nlayer,igcm_generic_gas)
             comm_DQICE(1:ngrid,1:nlayer)=pdq(1:ngrid,1:nlayer,igcm_generic_ice)
             ! comm_H2OICE_REFF(1:ngrid,1:nlayer) = reffrad_generic_zeros_for_wrf(1:ngrid,1:nlayer) ! for now zeros !
@@ -2417,5 +2417,5 @@
 !        do ig=1,ngrid
 !          if ((tracer).and.(water)) then
-!           pdq(ig,:,igcm_h2o_vap) = pdq(ig,:,igcm_h2o_vap) + lsf_dq(:)
+!           pdq(ig,:,igcm_h2o_gas) = pdq(ig,:,igcm_h2o_gas) + lsf_dq(:)
 !          endif
 !          pdt(ig,:) = pdt(ig,:) + lsf_dt(:)
Index: trunk/LMDZ.PLUTO/libf/phypluto/sfluxi.F
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/sfluxi.F	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/sfluxi.F	(revision 3275)
@@ -1,13 +1,13 @@
       module sfluxi_mod
-      
+
       implicit none
-      
+
       contains
-      
+
       SUBROUTINE SFLUXI(PLEV,TLEV,DTAUI,TAUCUMI,UBARI,RSFI,WNOI,DWNI,
      *                  COSBI,WBARI,NFLUXTOPI,NFLUXTOPI_nu,
-     *                  FMNETI,fluxupi,fluxdni,fluxupi_nu,
+     *                  FMNETI,fmneti_nu,fluxupi,fluxdni,fluxupi_nu,
      *                  FZEROI,TAUGSURF)
-      
+
       use radinc_h, only: NTfac, NTstart, L_LEVELS, L_NSPECTI, L_NGAUSS
       use radinc_h, only: L_NLAYRAD, L_NLEVRAD
@@ -15,12 +15,13 @@
       use comcstfi_mod, only: pi
       use gfluxi_mod, only: gfluxi
-      
+
       implicit none
-      
+
       integer NLEVRAD, L, NW, NG, NTS, NTT
-      
+
       real*8 TLEV(L_LEVELS), PLEV(L_LEVELS)
       real*8 TAUCUMI(L_LEVELS,L_NSPECTI,L_NGAUSS)
       real*8 FMNETI(L_NLAYRAD)
+      real*8 FMNETI_NU(L_NLAYRAD,L_NSPECTI)
       real*8 WNOI(L_NSPECTI), DWNI(L_NSPECTI)
       real*8 DTAUI(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
@@ -32,5 +33,5 @@
       real*8 fluxupi_nu(L_NLAYRAD,L_NSPECTI)
       real*8 FTOPUP
-      
+
       real*8 UBARI, RSFI, TSURF, BSURF, TTOP, BTOP, TAUTOP
       real*8 PLANCK, PLTOP
@@ -38,29 +39,30 @@
       real*8 FZEROI(L_NSPECTI)
       real*8 taugsurf(L_NSPECTI,L_NGAUSS-1), fzero
-      
+
       real*8 fup_tmp(L_NSPECTI),fdn_tmp(L_NSPECTI)
       real*8 PLANCKSUM,PLANCKREF
-      
+
 ! AB : variables for interpolation
       REAL*8 C1
       REAL*8 C2
       REAL*8 P1
-      
+
 !======================================================================C
-      
+
       NLEVRAD = L_NLEVRAD
-      
+
 ! ZERO THE NET FLUXES
       NFLUXTOPI = 0.0D0
-      
+
       DO NW=1,L_NSPECTI
         NFLUXTOPI_nu(NW) = 0.0D0
         DO L=1,L_NLAYRAD
            FLUXUPI_nu(L,NW) = 0.0D0
+           FMNETI_nu(L,NW)  = 0.0
            fup_tmp(nw)=0.0D0
            fdn_tmp(nw)=0.0D0
         END DO
       END DO
-      
+
       DO L=1,L_NLAYRAD
         FMNETI(L)  = 0.0D0
@@ -68,8 +70,8 @@
         FLUXDNI(L) = 0.0D0
       END DO
-      
+
 ! WE NOW ENTER A MAJOR LOOP OVER SPECTRAL INTERVALS IN THE INFRARED
 ! TO CALCULATE THE NET FLUX IN EACH SPECTRAL INTERVAL
-      
+
       TTOP  = TLEV(2)  ! JL12 why not (1) ???
       TSURF = TLEV(L_LEVELS)
@@ -86,5 +88,5 @@
       PLANCKREF = TSURF * TSURF
       PLANCKREF = sigma * PLANCKREF * PLANCKREF
-      
+
       DO NW=1,L_NSPECTI
 ! AB : PLANCKIR(NW,NTS) is replaced by P1, the linear interpolation result for a temperature TSURF
@@ -93,8 +95,8 @@
          PLANCKSUM = PLANCKSUM + P1 * DWNI(NW)
       ENDDO
-      
+
       PLANCKSUM = PLANCKREF / (PLANCKSUM * Pi)
 !JL12
-      
+
       DO 501 NW=1,L_NSPECTI
 ! SURFACE EMISSIONS - INDEPENDENT OF GAUSS POINTS
@@ -106,47 +108,49 @@
          BSURF = (1. - RSFI) * P1 * PLANCKSUM
          PLTOP = (1.0D0 - C2) * PLANCKIR(NW,NTT) + C2*PLANCKIR(NW,NTT+1)
-         
+
 ! If FZEROI(NW) = 1, then the k-coefficients are zero - skip to the
 ! special Gauss point at the end.
          FZERO = FZEROI(NW)
-         
+
          IF(FZERO.ge.0.99) goto 40
-         
+
          DO NG=1,L_NGAUSS-1
-            
+
             if(TAUGSURF(NW,NG).lt. TLIMIT) then
                fzero = fzero + (1.0D0-FZEROI(NW))*GWEIGHT(NG)
                goto 30
             end if
-            
+
 ! SET UP THE UPPER AND LOWER BOUNDARY CONDITIONS ON THE IR
 ! CALCULATE THE DOWNWELLING RADIATION AT THE TOP OF THE MODEL
 ! OR THE TOP LAYER WILL COOL TO SPACE UNPHYSICALLY
-            
+
 !            TAUTOP = DTAUI(1,NW,NG)*PLEV(2)/(PLEV(4)-PLEV(2))
             TAUTOP = TAUCUMI(2,NW,NG)
             BTOP   = (1.0D0-EXP(-TAUTOP/UBARI))*PLTOP
-            
+
 ! WE CAN NOW SOLVE FOR THE COEFFICIENTS OF THE TWO STREAM
 ! CALL A SUBROUTINE THAT SOLVES  FOR THE FLUX TERMS
-! WITHIN EACH INTERVAL AT THE MIDPOINT WAVENUMBER 
-            
+! WITHIN EACH INTERVAL AT THE MIDPOINT WAVENUMBER
+
             CALL GFLUXI(NLEVRAD,TLEV,NW,DWNI(NW),DTAUI(1,NW,NG),
      *                TAUCUMI(1,NW,NG),
      *                WBARI(1,NW,NG),COSBI(1,NW,NG),UBARI,RSFI,BTOP,
      *                BSURF,FTOPUP,FMUPI,FMDI)
-         
+
 ! NOW CALCULATE THE CUMULATIVE IR NET FLUX
             NFLUXTOPI = NFLUXTOPI+FTOPUP*DWNI(NW)*GWEIGHT(NG)
      *                * (1.0D0-FZEROI(NW))
-            
+
 ! and same thing by spectral band... (RDW)
             NFLUXTOPI_nu(NW) = NFLUXTOPI_nu(NW) + FTOPUP * DWNI(NW)
      *                       * GWEIGHT(NG) * (1.0D0-FZEROI(NW))
-            
+
             DO L=1,L_NLEVRAD-1
 !           CORRECT FOR THE WAVENUMBER INTERVALS
                FMNETI(L)  = FMNETI(L) + (FMUPI(L)-FMDI(L)) * DWNI(NW)
      *                    * GWEIGHT(NG)*(1.0D0-FZEROI(NW))
+               FMNETI_NU(L,NW)  = FMNETI_NU(L,NW) + (FMUPI(L)-FMDI(L))
+     *                    * DWNI(NW) * GWEIGHT(NG)*(1.0D0-FZEROI(NW))
                FLUXUPI(L) = FLUXUPI(L) + FMUPI(L)*DWNI(NW)*GWEIGHT(NG)
      *                    * (1.0D0-FZEROI(NW))
@@ -157,37 +161,39 @@
      *                          * GWEIGHT(NG) * (1.0D0 - FZEROI(NW))
             END DO
-            
+
    30       CONTINUE
-         
+
          END DO       !End NGAUSS LOOP
-         
+
    40    CONTINUE
-         
+
 ! SPECIAL 17th Gauss point
          NG     = L_NGAUSS
-         
+
 !         TAUTOP = DTAUI(1,NW,NG)*PLEV(2)/(PLEV(4)-PLEV(2))
          TAUTOP = TAUCUMI(2,NW,NG)
          BTOP   = (1.0D0-EXP(-TAUTOP/UBARI))*PLTOP
-         
+
 ! WE CAN NOW SOLVE FOR THE COEFFICIENTS OF THE TWO STREAM
 ! CALL A SUBROUTINE THAT SOLVES  FOR THE FLUX TERMS
-! WITHIN EACH INTERVAL AT THE MIDPOINT WAVENUMBER 
-         
+! WITHIN EACH INTERVAL AT THE MIDPOINT WAVENUMBER
+
          CALL GFLUXI(NLEVRAD,TLEV,NW,DWNI(NW),DTAUI(1,NW,NG),
      *                TAUCUMI(1,NW,NG),
      *                WBARI(1,NW,NG),COSBI(1,NW,NG),UBARI,RSFI,BTOP,
      *                BSURF,FTOPUP,FMUPI,FMDI)
-         
+
 ! NOW CALCULATE THE CUMULATIVE IR NET FLUX
          NFLUXTOPI = NFLUXTOPI+FTOPUP*DWNI(NW)*FZERO
-         
+
 !         and same thing by spectral band... (RW)
          NFLUXTOPI_nu(NW) = NFLUXTOPI_nu(NW)
      *      +FTOPUP*DWNI(NW)*FZERO
-         
+
          DO L=1,L_NLEVRAD-1
 ! CORRECT FOR THE WAVENUMBER INTERVALS
             FMNETI(L)  = FMNETI(L)+(FMUPI(L)-FMDI(L))*DWNI(NW)*FZERO
+            FMNETI_nu(L,NW)  = FMNETI_nu(L,NW)+(FMUPI(L)-FMDI(L))
+     *       *DWNI(NW)*FZERO
             FLUXUPI(L) = FLUXUPI(L) + FMUPI(L)*DWNI(NW)*FZERO
             FLUXDNI(L) = FLUXDNI(L) + FMDI(L)*DWNI(NW)*FZERO
@@ -196,8 +202,8 @@
      *                       + FMUPI(L) * DWNI(NW) * FZERO
          END DO
-         
+
   501 CONTINUE      !End Spectral Interval LOOP
 ! *** END OF MAJOR SPECTRAL INTERVAL LOOP IN THE INFRARED****
-      
+
       END SUBROUTINE SFLUXI
 
Index: trunk/LMDZ.PLUTO/libf/phypluto/sfluxv.F
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/sfluxv.F	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/sfluxv.F	(revision 3275)
@@ -2,11 +2,12 @@
 
       implicit none
-      
+
       contains
-      
+
       SUBROUTINE SFLUXV(DTAUV,TAUV,TAUCUMV,RSFV,DWNV,WBARV,COSBV,
      *                  UBAR0,STEL,NFLUXTOPV,FLUXTOPVDN,
-     *                  NFLUXOUTV_nu,NFLUXGNDV_nu,
-     *                  FMNETV,FLUXUPV,FLUXDNV,FZEROV,taugsurf)
+     *                  NFLUXOUTV_nu,NFLUXGNDV_nu,NFLUXTOPV_nu,
+     *                  FMNETV,FMNETV_NU,FLUXUPV,FLUXDNV,
+     *                  FZEROV,taugsurf)
 
       use radinc_h, only: L_TAUMAX, L_LEVELS, L_NSPECTV, L_NGAUSS
@@ -18,4 +19,5 @@
 
       real*8 FMNETV(L_NLAYRAD)
+      real*8 FMNETV_NU(L_NLAYRAD,L_NSPECTV)
       real*8 TAUCUMV(L_LEVELS,L_NSPECTV,L_NGAUSS)
       real*8 TAUV(L_NLEVRAD,L_NSPECTV,L_NGAUSS)
@@ -27,4 +29,5 @@
       real*8 FLUXUPV(L_NLAYRAD), FLUXDNV(L_NLAYRAD)
       real*8 NFLUXTOPV, FLUXUP, FLUXDN,FLUXTOPVDN
+      real*8 NFLUXTOPV_nu(L_NSPECTV)
       real*8 NFLUXOUTV_nu(L_NSPECTV)
       real*8 NFLUXGNDV_nu(L_NSPECTV)
@@ -50,4 +53,8 @@
          NFLUXOUTV_nu(NW)=0.0
          NFLUXGNDV_nu(NW)=0.0
+         NFLUXTOPV_nu(nw)=0.0
+         DO L=1,L_NLAYRAD
+           FMNETV_NU(L,NW) = 0.0
+        END DO
       END DO
 
@@ -64,5 +71,5 @@
 
       DO 500 NW=1,L_NSPECTV
-      
+
         F0PI = STEL(NW)
 
@@ -84,5 +91,5 @@
           BSURF = 0.
 C         LOOP OVER THE NTERMS BEGINNING HERE
- 
+
 
 !      FACTOR    = 1.0D0 - WDEL(1)*CDEL(1)**2
@@ -96,14 +103,14 @@
 C         CALL A SUBROUTINE THAT SOLVES  FOR THE FLUX TERMS
 C         WITHIN EACH INTERVAL AT THE MIDPOINT WAVENUMBER
-C 
-C         FUW AND FDW ARE WORKING FLUX ARRAYS THAT WILL BE USED TO 
+C
+C         FUW AND FDW ARE WORKING FLUX ARRAYS THAT WILL BE USED TO
 C         RETURN FLUXES FOR A GIVEN NT
 
 
           CALL GFLUXV(DTAUV(1,NW,NG),TAUV(1,NW,NG),TAUCUMV(1,NW,NG),
-     *                WBARV(1,NW,NG),COSBV(1,NW,NG),UBAR0,F0PI,RSFV(NW),    
+     *                WBARV(1,NW,NG),COSBV(1,NW,NG),UBAR0,F0PI,RSFV(NW),
      *                BTOP,BSURF,FMUPV,FMDV,DIFFV,FLUXUP,FLUXDN)
 
-C         NOW CALCULATE THE CUMULATIVE VISIBLE NET FLUX 
+C         NOW CALCULATE THE CUMULATIVE VISIBLE NET FLUX
 
           NFLUXTOPV = NFLUXTOPV+(FLUXUP-FLUXDN)*GWEIGHT(NG)*
@@ -114,4 +121,6 @@
             FMNETV(L)=FMNETV(L)+( FMUPV(L)-FMDV(L) )*
      *                           GWEIGHT(NG)*(1.0-FZEROV(NW))
+            FMNETV_NU(L,NW)=FMNETV_NU(L,NW)+( FMUPV(L)-FMDV(L) )*
+     *                           GWEIGHT(NG)*(1.0-FZEROV(NW))
             FLUXUPV(L) = FLUXUPV(L) + FMUPV(L)*GWEIGHT(NG)*
      *                   (1.0-FZEROV(NW))
@@ -120,4 +129,9 @@
           END DO
 
+c         and same thing by spectral band... (RDW)
+          NFLUXTOPV_nu(NW) = NFLUXTOPV_nu(NW)
+     *      +(FLUXUP-FLUXDN)*GWEIGHT(NG)*
+     *                          (1.0-FZEROV(NW))
+
 c     band-resolved flux leaving TOA (RDW)
           NFLUXOUTV_nu(NW) = NFLUXOUTV_nu(NW)
@@ -133,9 +147,9 @@
           DIFFVT = DIFFVT + DIFFV*GWEIGHT(NG)*(1.0-FZEROV(NW))
 
-   30     CONTINUE 
-
-        END DO   ! the Gauss loop 
-
-   40   continue 
+   30     CONTINUE
+
+        END DO   ! the Gauss loop
+
+   40   continue
 C       Special 17th Gauss point
 
@@ -143,9 +157,9 @@
 
 C       SET UP THE UPPER AND LOWER BOUNDARY CONDITIONS ON THE VISIBLE
- 
+
         BTOP = 0.0
 
 C       LOOP OVER THE NTERMS BEGINNING HERE
- 
+
         ETERM = MIN(TAUV(L_NLEVRAD,NW,NG),TAUMAX)
         BSURF = RSFV(NW)*UBAR0*STEL(NW)*EXP(-ETERM/UBAR0)
@@ -155,6 +169,6 @@
 C       CALL A SUBROUTINE THAT SOLVES  FOR THE FLUX TERMS
 C       WITHIN EACH INTERVAL AT THE MIDPOINT WAVENUMBER
-C 
-C       FUW AND FDW ARE WORKING FLUX ARRAYS THAT WILL BE USED TO 
+C
+C       FUW AND FDW ARE WORKING FLUX ARRAYS THAT WILL BE USED TO
 C       RETURN FLUXES FOR A GIVEN NT
 
@@ -164,5 +178,5 @@
 
 
-C       NOW CALCULATE THE CUMULATIVE VISIBLE NET FLUX 
+C       NOW CALCULATE THE CUMULATIVE VISIBLE NET FLUX
 
         NFLUXTOPV = NFLUXTOPV+(FLUXUP-FLUXDN)*FZERO
@@ -170,8 +184,13 @@
         DO L=1,L_NLAYRAD
           FMNETV(L)=FMNETV(L)+( FMUPV(L)-FMDV(L) )*FZERO
+          FMNETV_NU(L,NW)=FMNETV_NU(L,NW)+( FMUPV(L)-FMDV(L) )*FZERO
           FLUXUPV(L) = FLUXUPV(L) + FMUPV(L)*FZERO
           FLUXDNV(L) = FLUXDNV(L) + FMDV(L)*FZERO
         END DO
 
+c         and same thing by spectral band... (RDW)
+          NFLUXTOPV_nu(NW) = NFLUXTOPV_nu(NW)
+     *      +(FLUXUP-FLUXDN)*FZERO
+
 c     band-resolved flux leaving TOA (RDW)
           NFLUXOUTV_nu(NW) = NFLUXOUTV_nu(NW)
@@ -196,3 +215,3 @@
 
       end module sfluxv_mod
-      
+
